<template>
<!--行政强制执行（加处罚款）决定书-->
  <el-main>
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-row>
        <el-col :span="12">
          <el-form-item label="文号" :label-width="formLabelWidth">
            <el-input v-model="form.unitName" placeholder="_______强加决 〔    〕第    号"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="当事人姓名(名称)"
            :label-width="formLabelWidth"
          >
            <el-input v-model="form.litigant" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="证件号/信用代码" :label-width="formLabelWidth">
            <el-input v-model="form.certNo" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="法人" :label-width="formLabelWidth">
            <el-input
              v-model="form.legalPerson"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="住址" :label-width="formLabelWidth">
        <el-input v-model="form.address" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="联系电话" :label-width="formLabelWidth">
            <el-input v-model="form.phone" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="送达日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.deliveryDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="送达文书" :label-width="formLabelWidth">
            <el-input v-model="form.deliveryDocuments" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="文号" :label-width="formLabelWidth">
            <el-input v-model="form.documentsUnitName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>

        <el-col :span="12">
          <el-form-item label="罚款金额(大写)" :label-width="formLabelWidth">
            <el-input v-model="form.penalty" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="履行日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.fulfillmentDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="截止日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.expirationDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="人民政府名称" :label-width="formLabelWidth">
            <el-input v-model="form.governmentName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="人民法院名称" :label-width="formLabelWidth">
            <el-input v-model="form.courtName" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="加处罚款（大写）" :label-width="formLabelWidth">
            <el-input v-model="form.additionalFines" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="盖章日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.stampDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="form.registerState!='1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="form.registerState!='1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import {getObj, saveObj} from "@/api/News/administrativeEnforcementDecision";
import WordView from "@/views/News/word-view";
import moment from "moment";
export default {
  name: "constraint_execute_decide",
  props:['isShowYulan','id','isFinish','processId'],
  components:{
    WordView
  },
  data() {
    return {
      showView:false,
      form: {
        litigant: "",
        certNo: "",
        address: "",
        legalPerson: "",
        phone: "",
        deliveryDate: "",
        deliveryDocuments:'',
        unitName: "",
        penalty: "",
        fulfillmentDate: "",
        expirationDate: "",
        governmentName: "",
        courtName: "",
        additionalFines: "",
        stampDate: "",
      },
      formLabelWidth: "140px",
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        if (res.data.code == 0) {
          // 转换null为""
          let v = res.data.data;
          for (let attr in v) {
            if (v[attr] == null) {
              v[attr] = "";
            }
          }
          let str = JSON.stringify(v);
          let data = JSON.parse(str);
          this.form = data;
        }
      });
    },
    dataFormSubmit(type) {
      console.log(type)
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
                obj.$emit('getDataList');
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
              obj.$emit('getDataList');
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/administrativeEnforcementDecision.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/administrativeEnforcementDecision.docx", "行政强制执行（加处罚款）决定书.docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.deliveryDate != '' && data.deliveryDate != null) {
        data.deliveryDate = moment(data.deliveryDate).format('YYYY年MM月DD日');
      }else {
        data.deliveryDate = '  年  月  日'
      }

      if (data.fulfillmentDate != '' && data.fulfillmentDate != null) {
        data.fulfillmentDate = moment(data.fulfillmentDate).format('YYYY年MM月DD日');
      }else {
        data.fulfillmentDate = '  年  月  日'
      }

      if (data.expirationDate != '' && data.expirationDate != null) {
        data.expirationDate = moment(data.expirationDate).format('YYYY年MM月DD日');
      }else {
        data.expirationDate = '  年  月  日'
      }

      if (data.stampDate != '' && data.stampDate != null) {
        data.stampDate = moment(data.stampDate).format('YYYY年MM月DD日');
      }else {
        data.stampDate = '  年  月  日'
      }


      return data;
    }
  }
}
</script>

<style scoped>

</style>
